]>
diplodocus.org Git - nmh/blob - uip/mhmail
3 # mhmail -- simple mail program
5 # This code is Copyright (c) 2012, by the authors of nmh. See the
6 # COPYRIGHT file in the root directory of the nmh distribution for
7 # complete copyright information.
9 # Emulation of compiled mhmail(1), with these differences:
10 # * Adds -send/-nosend, -headerfield, and -attach options.
11 # * Adds optional -to switch for recipient addresses.
12 # * Supports all post(8) (by default, without -profile) or send(1)
13 # (with -profile) options.
14 # * Optionally (with -profile) obeys the users profile, including
15 # AliasFile and send entries.
16 # * Instead of silently not sending an empty message, notifies user
17 # "mhmail: empty message not sent, use -body '' to force."
18 # * The compiled mhmail dropped a trailing newline from the -body argument.
19 # * Drops support for undocumented -queue option.
21 usage
='Usage: mhmail [-t(o)] addrs ... [switches]
23 -at(tach) file [-at(tach) file] ...
27 -hea(derfield) name:value [-hea(derfield) name:value] ...
35 and all post(8)/send(1) switches
36 mhmail with no arguments is equivalent to inc'
39 #### Find directory of this script. Bourne shell just puts the program
40 #### name in $0 if it's found from the PATH, so search that if necessary.
46 [ -f "${d:=.}/$1" -a -x "$d/$1" ] && printf "$d" && break
52 nmhbindir
=`cd "${bindir}" && pwd`
55 #### Checks for missing mandatory arguments.
57 if [ ${attacharg} -eq 1 ]; then
58 printf "mhmail: missing argument to -attach\n"; exit 1
59 elif [ ${bodyarg} -eq 1 ]; then
60 printf "mhmail: missing argument to -body\n"; exit 1
61 elif [ ${ccarg} -eq 1 -a "${cclist}"x
= x
]; then
62 printf "mhmail: missing argument to -cc\n"; exit 1
63 elif [ ${fromarg} -eq 1 ]; then
64 printf "mhmail: missing argument to -from\n"; exit 1
65 elif [ ${headerfieldarg} -eq 1 ]; then
66 printf "mhmail: missing argument to -headerfield\n"; exit 1
67 elif [ ${subjectarg} -eq 1 ]; then
68 printf "mhmail: missing argument to -subject\n"; exit 1
69 elif [ ${toarg} -eq 1 ]; then
70 printf "mhmail: missing argument to -to\n"; exit 1
75 #### Emulate mhmail for reading mail.
76 exec "${nmhbindir}"/inc
78 #### Go through all the switches so we can build the draft.
79 tolist
= ## To: addresses
80 toarg
=0 ## whether currently handling -to
81 attacharg
=0 ## whether currently handling -attach
82 attach_send_switch_added
=0 ## whether added "-attach Nmh-Attachment" switch
83 body
= ## contents of the message body
84 bodyarg
=0 ## whether currently handling -body
85 cclist
= ## Cc: addresses
86 ccarg
=0 ## whether currently handling -cc
87 from
= ## From: contents
88 fromarg
=0 ## whether currently handling -from
89 headerfieldlist
= ## header fields to be added to draft
90 headerfieldarg
=0 ## whether currently handling -headerfield
91 mhmailswitch
=0 ## whether currently handling any mhmail switch
92 subject
= ## Subject: contents
93 subjectarg
=0 ## whether currently handling -subject
94 resent
=0 ## whether resending
95 postsendargs
= ## switches to pass on to post or send
96 post_send_switch_arg
=0 ## whether currently handling a post/send switch
97 use_send
=0 ## use post (default) or send (-profile)
98 sendsw
=1 ## to send (default) or not to send
101 #### Post and send won't accept -f -or -s because they'd be
102 #### ambiguous, so no conflicts with them. And they don't have
103 #### -b, -c, -r, -t. For the new switches that compiled mhmail
104 #### didn't have: let -p indicate mhmail -profile, not send
105 #### -port. -send masks the send(1) -send switch. -attach
106 #### masks the send(1) -attach switch.
107 -at|-att|-atta|-attac|-attach)
111 if [ ${attach_send_switch_added} -eq 0 ]; then
112 #### Override any send -attach switch in user's profile.
114 "${postsendargs:+${postsendargs} }-attach Nmh-Attachment"
115 attach_send_switch_added
=1
117 -b|-bo|-bod|-body) mhmailswitch
=1; bodyarg
=1 ;;
118 -c|-cc) mhmailswitch
=1; ccarg
=1 ;;
119 -f|-fr|-fro|-from) mhmailswitch
=1; fromarg
=1 ;;
120 -hea|-head|-heade|-header|-headerf|-headerfi|-headerfie|-headerfiel|\
121 -headerfield) mhmailswitch
=1; headerfieldarg
=1 ;;
122 -hel|-help) printf "${usage}\n"; exit ;;
123 -nose|-nosen|-nosend) mhmailswitch
=1; sendsw
=0 ;;
124 -p|-pr|-pro|-prof|-profi|-profil|-profile) mhmailswitch
=1; use_send
=1 ;;
125 -resend) printf "mhmail: did you mean -resent instead of -resend?\n" 1>&2
127 -r|-re|-res|-rese|-resen|-resent) mhmailswitch
=1; resent
=1 ;;
128 -se|-sen|-send) mhmailswitch
=1; sendsw
=1 ;;
129 -su|-sub|-subj|-subje|-subjec|-subject) mhmailswitch
=1; subjectarg
=1 ;;
130 -t|-to) toarg
=1; ccarg
=0 ;;
131 -v|-ve|-ver|-vers|-versi|-versio|-version)
132 #### Cheat instead of using autoconf and make to fill in the version.
133 "${nmhbindir}"/mhpath
-v | sed 's/mhpath/mhmail/'; exit ;;
134 -*) if [ ${mhmailswitch} -eq 1 ]; then
138 post_send_switch_arg
=1
139 postsendargs
="${postsendargs:+${postsendargs} }${arg}" ;;
141 if [ ${bodyarg} -eq 1 ]; then
145 #### Allow -body "" by using just a newline for the body.
146 [ "${body}"x
= x
] && body
='
148 elif [ ${fromarg} -eq 1 ]; then
151 elif [ ${subjectarg} -eq 1 ]; then
154 elif [ ${attacharg} -eq 1 ]; then
155 headerfieldlist
="${headerfieldlist:+${headerfieldlist}}\
156 Nmh-Attachment: ${arg}
159 elif [ ${headerfieldarg} -eq 1 ]; then
160 #### It's not strictly necessary to have one space after
161 #### the : that separates the header field name from the
162 #### body, but do it to avoid surprising someone.
163 add
=`printf "${arg}" | sed -e 's/:/: /' -e 's/: /: /'`
164 headerfieldlist
="${headerfieldlist:+${headerfieldlist}}${add}
167 elif [ ${post_send_switch_arg} -eq 1 ]; then
168 postsendargs
="${postsendargs:+${postsendargs} }${arg}"
169 elif [ ${ccarg} -eq 1 ]; then
170 #### ccarg can only be reset to 0 by -to.
171 cclist
="${cclist:+${cclist}, }${arg}"
174 tolist
="${tolist:+${tolist}, }${arg}"
180 #### Check for at least one address and -from.
181 if [ "${tolist}"x
= x
]; then
182 printf "mhmail: usage: mhmail addrs ... [switches]\n"; exit 1
184 if [ "${from}"x
= x
]; then
185 nmhlibdir
=`${nmhbindir}/mhparam libdir`/
186 from
=`${nmhlibdir}ap -format '%(localmbox)' 0`
189 #### Check for missing mandatory arguments.
193 [ ${resent} -eq 0 ] && prefix
= || prefix
='Resent-'
194 header
="${prefix}To: ${tolist}
196 [ "${cclist}"x
= x
] || header
="${header}${prefix}Cc: ${cclist}
198 [ "${subject}"x
= x
] || header
="${header}${prefix}Subject: ${subject}
200 [ "${from}"x
= x
] || header
="${header}${prefix}From: ${from}
203 if [ "${headerfieldlist}" ]; then
204 header
="${header}${headerfieldlist}"
207 #### Set up a file to supply as a draft to post/send. And set a
208 #### trap to remove it. send moves the file to a backup, so it will
209 #### remove that, too.
211 tmpdir
="${MHTMPDIR:-${TMPDIR:-${TMP:-`${nmhbindir}/mhpath +`}}}"
212 tmpfile
="${tmpdir}/mhmail$$"
213 tmpfilebackup
="${tmpdir}/[,#]mhmail$$"
217 if [ ${resent} -eq 0 ]; then
218 #### Add blank line after header if not resending.
221 message_file
="${tmpfile}"
223 if [ ${use_send} -eq 0 ]; then
224 postsendargs
="${postsendargs:+${postsendargs} }-dist"
225 message_file
="${tmpfile}"
227 #### When resending with send, tmpfile will just contain the
228 #### Resent- header fields. "${tmpfileresent}" will contain
229 #### the message that is being resent.
230 tmpfileresent
="${tmpdir}/mhmail-resent$$"
231 mhdist
=1; export mhdist
232 mhaltmsg
=${tmpfileresent}; export mhaltmsg
233 message_file
="${tmpfileresent}"
234 printf "" >"${message_file}" || exit 2
238 trap 'rm -f '"${tmpfile}"' '"${tmpfilebackup}"' '"${tmpfileresent}" EXIT
240 if [ "${body}"x
= x
]; then
241 #### First put message header in the file.
242 printf "${header}" >"${tmpfile}" || exit 2
244 tmpfile_size_before
=`wc -c "${message_file}"`
245 #### Now grab the body from stdin. cat >> handles blank lines
246 #### better than body=`cat`.
247 cat >>"${message_file}" || exit 2
248 tmpfile_size_after
=`wc -c "${message_file}"`
250 #### Don't allow an empty body (from stdin). Use string
251 #### comparison so we don't have to strip the filename, etc.
252 if [ "${tmpfile_size_before}" = "${tmpfile_size_after}" ]; then
253 printf "mhmail: empty message not sent, use -body '' to force.\n" 1>&2
257 #### Add trailing newline to body if it doesn't have one.
258 if [ `tail -n 1 "${message_file}" | wc -l` -ne 1 ]; then
259 printf "\n" >>"${message_file}" || exit 2
262 #### Add trailing newline to body if it doesn't have one.
263 [ `printf "${body}" | tail -n 1 | wc -l` -ne 1 ] && body
="${body}
266 if [ "${tmpfileresent}" ]; then
267 #### Put just the new message header in the file.
268 printf "${header}" >"${tmpfile}" || exit 2
269 #### and the body in the file to resend.
270 printf "${body}" >"${tmpfileresent}" || exit 2
272 #### Put message header and body in the file.
273 printf "${header}${body}" >"${tmpfile}" || exit 2
277 if [ ${sendsw} -eq 0 ]; then
280 if [ ${use_send} -eq 0 ]; then
281 post_or_send
=`${nmhbindir}/mhparam postproc`
283 post_or_send
="${nmhbindir}/send"
286 if "${post_or_send}" "${tmpfile}" ${postsendargs}; then
290 mv -f "${tmpfile}" dead.letter
291 printf "Letter saved in dead.letter\n"